﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public class GetY : CodeNode, INumericalMethod {
    public override int MinimumArity { get { return 0; } }
    public override int MaximumArity { get { return 0; } }

    [Storable]
    public override string Prefix { get; set; }

    [Storable]
    public override string Suffix { get; set; }

    [StorableConstructor]
    private GetY(bool deserializing) : base(deserializing) { }
    private GetY(GetY original, Cloner cloner)
      : base(original, cloner) {

    }

    public GetY()
      : base("GetY", "Returns the Y position of the robot. (0,0) is at the bottom left of the battlefield.") {
      this.Prefix = "getY(";
      this.Suffix = ")";
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new GetY(this, cloner);
    }

    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
      return this.Prefix + this.Suffix;
    }
  }
}